package iotrmi.Java.sample;

import java.io.IOException;
import java.util.Set;
import java.util.Arrays;
import iotrmi.Java.IoTRMIObject;

public class CallBack_Skeleton {

	private String[] methodSignatures = {

		"intprintInt()",
		"voidsetInt(int)"
	};

	private CallBackInterface cb;
	private IoTRMIObject rmiObj;


	/**
	 * Constructors
	 */
	public CallBack_Skeleton(CallBackInterface _cb, int _port) throws
		ClassNotFoundException, InstantiationException,
			IllegalAccessException, IOException {

		cb = _cb;
		System.out.println("Creating CallBack_Skeleton and waiting!");
		rmiObj = new IoTRMIObject(_port, methodSignatures);
	}


	public void waitRequestInvokeMethod() throws IOException {

		// Loop continuously waiting for incoming bytes
		while (true) {

			rmiObj.getMethodBytes();
			String methodSign = rmiObj.getSignature();
			Object[] paramObj = null;
			Object retObj = null;
			System.out.println("Method sign: " + methodSign);

			if (methodSign.equals("intprintInt()")) {
				//paramObj = rmiObj.getMethodParams(new Class<?>[] { }, 
				//	new Class<?>[] { null }, new Class<?>[] { null });
				retObj = cb.printInt();
			} else if (methodSign.equals("voidsetInt(int)")) {
				paramObj = rmiObj.getMethodParams(new Class<?>[] { int.class }, 
					new Class<?>[] { null }, new Class<?>[] { null });
				cb.setInt((int) paramObj[0]);
			} else
				throw new Error("Signature un-recognized!");
			System.out.println("Return object: " + retObj);

			if (retObj != null) {
				rmiObj.sendReturnObj(retObj);
			}
			System.out.println("Servicing remote call for method: " + methodSign);
		}
	}


	public static void main(String[] args) throws Exception {

		int port = 5010;
		CallBack cb = new CallBack(23);
		CallBack_Skeleton cbSkel = new CallBack_Skeleton(cb, port);
		cbSkel.waitRequestInvokeMethod();
	}
}
